#!/usr/local/bin/perl
eval 'exec /usr/local/bin/perl -S $0 ${1+"$0"}'
  if $running_under_some_shell;
#Copyright 1994-1995 Jacob C. Kesinger n9146070@cc.wwu.edu

#Usage:  htmlatex foo.html >bar.tex

#VERSION 0.21 BETA
#HISTORY
#0.21       Removed underlining from anchors.  Fixed bug with </p>
#           matching too friendly.  Added \item[] when an itemlist
#           is inside a description list. Added opeyspace to <pre>,<xmp>,
#           and <listing>.  Fixed handling of </p> on alignments.       
#           <lh> added as just another <li>.  <em> changed to {\it} for
#           L2.09.  Started work on <sup> and <sub>, kinda works for 
#           very short text (which is most of what it is, right?)
#           Fixed handling of ``_''.  dir
#0.20       Added <q></q>, <font size= ...>, <p align = ...>.
#           &parse_tag() broken into &get_tag() (gets next tag) and
#           &parse_html() (parses ordinary HTML). Parallel situation 
#           with escape chars. Started adding math tags.  Re-arranged 
#           cases in &tag_mode and returning 
#           earlier (so slight speed improvement).  
#           Fixed <img alt=>.  Changed <title>.  
#0.13       Changed \\textit{} back to {\\it} for L2.09 compatibility.
#           Changed ``\'' and ``"''. Changed ISO stuff; everything is
#           now stored in an AA.  Added <bq></bq>.
#0.12       Added \".  Qualifiers appear to be being read. Fixed <u>.
#           Changed handling of style tags (i.e. {\\it } to\\textit{ } )
#           Added <select>, <option>.  Changed <dfn>, <em>, <var>
#           Added <img..>.
#0.11       Changed <ul> inside of <dl>.  Added more tags.  File read in
#           $readsize blocks.
#0.10       Changed from straight substition on a whole string to
#           state operation.  New tags. File read
#           character by character.
#0.01       Slurped in whole file instead of while (<>)

#Working on:
#Math.  

#To-do:
#Fix handling of bars (underline, anchor, and strike)
#Note.  Table.  Div. Banner.  HR attributes(?).
#Forms stuff? (i.e. textarea?).   Fix LH.

#GLOBAL VARIABLES
$readsize = 2000;  #how many characters will we read in at a time?  More a 
                   #constant than a variable.
$preserve_whitespace = 0;  #set to one in <pre>, <listing>, <xmp>
$dtlevel = 0;  #how many <dt>s without <dd>s have we found?
$translatespecials = 1;
$metspace = 0;
$fontsize = 3;
$oldfontsizes[0] = 3;
$fontopener = '{';
$fontcloser = '}';
$thisparagraph = "";
$thistag = "";
$qualifiers{'blank'} = "";
$thisesc = "";
$inmath = 0;
#These tags have direct LaTeX equivalents.
%latexequiv = ("cite", "{\\it ", "/cite", "}",
               "i", "{\\it ", "/i", "}",
               "b", "{\\bf ", "/b", "}",
               "u", "\\underbar{", "/u", "}",
               "tt", "{\\tt ", "/tt", "}",
               "em", "{\\it ", "/em", "}",
               "strong", "{\\bf ", "/strong", "}",
               "address", "{\\it ", "/address", "}",
               "samp", "{\\tt ", "/samp", "}",
               "code", "{\\tt ", "/code", "}",
               "kbd", "{\\tt ", "/kbd", "}",
               "var", "{\\sl ", "/var", "}",
               "dfn", "{\\sc ", "/dfn", "}",  #add <strike>
               "title", "\\section*{ ", "/title", "}",
               "blockquote", "\\begin{quotation} ", 
               "/blockquote", "\\end{quotation} ",
               "bq", "\\begin{quotation} ", "/bq", "\\end{quotation} ",
               "q", "``","/q","''",
               "br", "\\newline ", "hr", "\\hrule ",
               "h1", "\\section*{", "/h1", "} ",
               "h2", "\\subsection*{", "/h2", "} ",
               "h3", "\\subsubsection*{", "/h3", "} ",
               "h4", "\\subsubsection*{", "/h4", "}" ,
               "h5", "\\paragraph*{", "/h5", "} ",
               "h6", "\\subparagraph*{", "/h6", "} ",
               "li", "\\item ", "option", "\\item",
               "lh","\\item ", 
              );

%latexinmathopen = ("sup","\${}^{\\rm ","sub","\${}_{\\rm ");
%latexinmathclose = ("/sup","}\$","/sub","}\$");

#These are the equivalents in LaTeX of HTML's lists.  Note that
#<menu>, <select>, and <dir> are currently treated the same as
#<ul>, and the compact attribute is not supported.
%latexlistequiv =("ol", "\\begin{enumerate}", "/ol", "\\end{enumerate}",
                  "ul", "\\begin{itemize}", "/ul", "\\end{itemize}",
                  "select", "\\begin{itemize}", "/select", "\\end{itemize}",
                  "menu", "\\begin{itemize}", "/menu", "\\end{itemize}",
                  "dir", "\\begin{itemize}", "/dir", "\\end{itemize}",
                  "dl", "\\begin{description}","/dl", "\\end{description}");

#these are itemlists, which means that we're having trouble
#with them inside of <dl>s.
%itemliststarter = ("ol", 1, "ul", 1, "menu", 1, "dir", 1, "select", 1);
%itemlistcloser = ("/ol", 1, "/ul", 1, "/menu", 1, "/dir", 1, "/select", 1);

#A spacer means that we already have had a space.
%spacers = ("p", 1, "br", 1, "/h1", 1,"/h2", 1,"/h3", 1,"/h4",1,
            "/h5", 1,"/h6", 1);

#Ignore these tags.  I suppose we could stick them in %latexequiv
#above with values "%\n".  That might be a good idea....
%ignore = ("head", 1, "/head", 1, "html", 1, "/html", 1,
           "body", 1, "/body", 1, "/li", 1, "/br", 1, "isindex",1,
           "/lh",1
          );

#What to do when we have a preformatted section?
%obeylines = ("pre", "\\begin{obeylines}\\begin{obeyspaces}",
              "xmp", "\\begin{obeylines}\\begin{obeyspaces}{\\tt ",
              "listing", "\\begin{obeylines}\\begin{obeyspaces}{\\small\\tt "
             );
%closeobeylines = ("/pre", "\\end{obeyspaces}\\end{obeylines}",
                   "/xmp", "}\\end{obeyspaces\\end{obeylines}",
                   "/listing", "}\\end{obeyspaces\\end{obeylines}"
                  );
#What are things that can close <dt>s?  Aside from <dl>, of course
%dtcloser = ("/dt", 1, "dd", 1, "/dd", 1);

#The various font sizes
@fontlist = ("\\footnotesize","\\small","\\normal","\\large","\\Large",
             "\\LARGE","\\huge");

%paralignopen = ("left", "\\begin{flushleft}", "right","\\begin{flushright}",
             "center", "\\begin{center}");
%paralignend = ("left", "\\end{flushleft}", "right","\\end{flushright}",
             "center", "\\end{center}");
$paragraph = "\\par ";

#There are things in HTML that LaTeX doesn't like.
%htmlspecial = ("@", "{\\char64}", "\$", "\\\$", "%", "\\%", "~", "\\~{}",
                "{","\\{", "}", "\\}", "#", "\\#", "_", "\\_",
                "^", "\\^{}", "]", "\$\\]\$","[", "\$\\[\$",
                "\\", "\\hbox{\$\\backslash\$}","\"", "{\\tt{}\"}"
               );
#What are the ampersand escape sequences?
#Note that this might be the only part of HTML that is case sensitive;
#I refer to sequences like &AElig and &Oslash.  What I will do is
#read in the tag, check to see if that tag is in here; if not, convert the
#tag to lowercase and check again.
#also, note that ``#'' seems to be in some numerical tags but not others.
%isolist = ("amp", "\\\&", "quot", "{\\tt{}\"}", "gt", "\\hbox{\$>\$}",
            "lt", "\\hbox{\$<\$}", "aacute", "\\'a",
            #Lowercase accents.
            "aacute", "\\'a","eacute", "\\'e","iacute", "\\'i",
            "oacute", "\\'o","uacute", "\\'u","yacute", "\\'y",
            "agrave", "\\`a","egrave", "\\`e","igrave", "\\`i",
            "ograve", "\\`o","ugrave", "\\`u",
            "acirc", "\\^a","ecirc", "\\^e","icirc", "\\^i",
            "ocirc", "\\^o","ucirc", "\\^u",
            "atilde", "\\~a","etilde", "\\~e","itilde", "\\~i",
            "ntilde", "\\~n","otilde", "\\~o","utilde", "\\~u",
            "auml", "\\\"a","euml", "\\\"e","iuml", "\\\"i",
            "ouml", "\\\"o","uuml", "\\\"u","yuml", "\\\"y",
            #Uppercase accents.
            "Aacute", "\\'A","Eacute", "\\'E","Iacute", "\\'I",
            "Oacute", "\\'O","Uacute", "\\'U","Yacute", "\\'Y",
            "Agrave", "\\`A","Egrave", "\\`E","Igrave", "\\`I",
            "Ograve", "\\`O","Ugrave", "\\`U",
            "Acirc", "\\^A","Ecirc", "\\^E","Icirc", "\\^I",
            "Ocirc", "\\^O","Ucirc", "\\^U",
            "Atilde", "\\~A","Etilde", "\\~E","Itilde", "\\~I",
            "Ntilde", "\\~N","Otilde", "\\~O","Utilde", "\\~U",
            "Auml", "\\\"A","Euml", "\\\"E","Iuml", "\\\"I",
            "Ouml", "\\\"O","Uuml", "\\\"U","Yuml", "\\\"Y",
            #Misc accents.
            "AElig", "\\AE","aelig", "\\ae","OElig", "\\OE","oelig", "\\oe",
            "Oslash", "\\O","oslash", "\\o","Ccedil", "\\c C",
            "ccedil", "\\c c", "Aring", "\\A", "aring", "\\a",
            "szlig", "\\ss",
            #More stuff (from HTML3?)
            "nbsp", "\~", "ensp","\\kern.5em","emsp","\\kern1.0em",
            "endash","--","emdash","---", 
            #Numerical (misc. and low ascii)
            "#09", "\\qquad", "#10", "\n", "32", " ",
            "247", "\\hbox{\$\\div\$}","215","\\hbox{\$\\times\$}",
            "191", "?'", "190", "\\hbox{\$\\frac34\$}",
            "189", "\\hbox{\$\\frac12\$}","188", "\\hbox{\$\\frac14\$}",
            "187","\\hbox{\$\\gg\$}","185","\\hbox{\${}^1\$}",
            "184","\\c ", "183", "\\D ", "182", "\\P ",
            "181", "\\hbox{\$\\mu\$}", "180", "\\'",
            "179","\\hbox{\${}^3\$}", "178", "\\hbox{\${}^2\$}",
            "177", "\\hbox{\$\\pm\$}","176", "\\hbox{\${}^\\circ\$}",
            "175", "\\B ",
"174", "{{\\ooalign{\\hfil\\raise.07ex\\hbox{R}\\hfil\\crcr\\mathhexbox20D}}}",
            "173", "\-", "172","\\hbox{\$\\neg\$}", "171", "\\hbox{\$\\ll\$}",
            #170 is undefined.  ``feminine ordinal''.
            "170", "",
            "169", "\\copyright ", "160", "\\\"", "167", "\\S",
            "166", "{\\tt |}",
            #165, 164 undefined.  ``Yen'' and ``Currency''
            "165", "", "164", "",
            "163", "{\\it \$}", "162", "\\hbox{\$\\cents\$}",
            "161", "!'","160","~",
            #Numerical equivalents (lower and uppercase accents)
            "192", "\\'A","193", "\\`A","194", "\\^A","195", "\\~A",
            "196", "\\A","197", "\\\"A","198", "\\AE","199", "\c C",
            "200", "\\'E","201", "\\`E","202", "\\^E","203", "\\\"E",
            "204", "\\'I","205", "\\`I","206", "\\^I","207", "\\\"I",
            #208 undefined.  Capital ETH.
            "208", "",
            "209", "\\~N",
            "210", "\\'O","211", "\\`O","212", "\\^O", "213","\\~O",
            "214", "\\\"O",      "216", "\\O", "217","\\'U",
            "218", "\\`U","219", "\\^U","220", "\\\"U", "221","\\'Y",
            #222 undefined.  Capital THORN.
            "222", "",
            "223", "\\ss","224", "\\'a", "225","\\'a",
            "226", "\\^a","227", "\\~","228", "\\~a", "229","\\\"a",
            "230", "\\ae","231", "\\c c","232", "\\'e", "233","\\`e",
            "234", "\\^e","235", "\\\"e","236", "\\'i", "237","\\`i",
            "238", "\\~i","298", "\\\"i",
            #240 undefined.  Small eth.
            "240", "",
            "241","\\~n",
            "242", "\\'o","243", "\\`o","244", "\\^o", "245","\\~o",
            "246", "\\\"o","248", "\\o", "249","\\'u",
            "250", "\\`u","251", "\\^u","252", "\\\"u", "253","\\'y",
            #254 undefined.  Small thorn.
            "254", "",
            "255", "\\\"y");

#Thankfully the HTML3 RFC has these equivs.  Should we always put a
#\hbox{$ ... $} around them?  Don't forget to put the space before the
#final quote if we don't....
%mathord = ("ldots","\\ldots ","cdots","\\cdots ","vdots","\\vdots ",
              "ddots","\\ddots ",
              "dotfill","\\dotfill",  #is this approp in context?
              "thinsp","\\,","sp","\\:","emsp","\\;","quad","\\quad ",
              "alpha","\\alpha ","beta","\\beta ","gamma","\\gamma ",
              "delta","\\delta ","epsilon","\\epsilon ",
              "vepsilon","\\varepsilon ","zeta","\\zeta ", "eta","\\eta",
              "theta","\\theta","vtheta","\\vartheta","iota","\\iota",
              "kappa","\\kappa","lambda","\\lambda","mu","\\mu","nu","\\nu",
              "xi","\\xi","omicron","\\hbox{o}","pi","\\pi","varpi","\\varpi",
              "rho","\\rho","varrho","\\varrho","sigma","\\sigma",
              "vsigma","\\varsigma","tau","\\tau","upsilon","\\upsilon",
              "phi","\\phi","varphi","\\varphi","chi","\\chi",
              "psi","\\psi","omega","\\omega",
              # I can't find uppercase letters in the specs.  Hello, my name
              # is Marc Andreesen.  I might as well add the rest of the
              # latin equivs in here soon....
              "Alpha","{\\rm A}","Beta","{\\rm B}","Gamma","\\Gamma ",
              "Delta","\\Delta ","Epsilon","{\\rm E}","Theta","\\Theta",
              "Lambda","\\Lambda","Xi","\\Xi","Pi","\\Pi","Sigma","\\Sigma",
              "Upsilon","\\Upsilon","Phi","\\Phi",
              "Psi","\\Psi","Omega","\\Omega",
              );


#====================
#=   MAIN PROGRAM   =
#====================
open(INFILE, $ARGV[0]) || die "Cannot open $ARGV[0]! $!\n";
print <<'Heading';
\documentstyle{article}
\begin{document}
Heading

BODY_LOOP:
while (1)
{
  $_ = &getnext();
  if (/\a/)
  {
    print "\\end{document}";
    exit;
  }
  elsif (/\w/)
  {
      if (/_/) 
      {print "\\_";}
      else {print $_;}
      $metspace = 0;
  }
  elsif (/\s/)
  {
    if (!($metspace))
    {
      $metspace++;
      print $_;
      if ($inmath) {print "~";}
    }
    elsif ($preserve_whitespace > 0) 
    {
      print $_;
      $metspace++;
    }
  }
  elsif (/</)
  {
    $metspace = 0;
    &get_tag();
    &parse_html();
  }
  elsif (/\&/)
  {
    $metspace = 0;
    &get_escape();
    &parse_escape();
  }
  elsif ($htmlspecial{$_})
  {
    print  $htmlspecial{$_};
    $metspace = 0;
  }
  else
  {
    print  $_;
    $metspace = 0;
  }
}

sub getnext
#this simulates getc().
{
  if (length($buffer) == 0)
  {
    read(INFILE, $buffer, $readsize);
    $buffer = reverse($buffer);
    if ($buffer) {return chop($buffer);} else {print "\\end{document}";exit 0;}
  }
  else {return chop($buffer);}
}



sub get_escape
{
   $_ = &getnext;
   if (/\#/) {$_ = &getnext;}
   $thisesc = "";
   while (/\w/)
   {
     $thisesc .= $_;
     $_ = &getnext;
   }
   if ((/</)||(/\&/))
   {$buffer .= $_;}
}

sub parse_escape
{
   if ($isolist{$thisesc})
     {print "$isolist{$thisesc}";}
   else
   {
     $thisesc =~ tr/A-Z/a-z/;   #Convert $_ to lowercase.
    print "$isolist{$thisesc}"; #it still might not be here, but what the heck.
   }
}


sub get_tag  #process HTML tags
{
  local($name) = "";
  $_ = &getnext;
  if (/\//)              #are we a closing tag?
  {                      #we have to have this because the while won't
    $name = "/";         #match otherwise.
    $_ = &getnext;
  }
  while (/\w/)           #read in the tag.
  {
    $name .= $_;
    $_ = &getnext;
  }
  #here is where we parse the qualifiers....
  local($quotecount) = 0;
  local($qualifiers) = '';
  local($qualifierspace ) = 0; #like $metspace, but local
  #I think this is correct, I still have to test it....
  #Well, I didn't test it and now I don't understand it... 1/29/95
  while (!( ($quotecount %2 == 0) && (/>/) ) )
#       1 2 3                   3    4    4 2 1
  {
    if (/\"/)
    { $quotecount++;$qualifierspace = 0;}
    #If we're in the middle of a quote, do nothing
    next if ($quotecount %2 == 1);
    #otherwise....
    if (/=/)
    { $_ = "\cD";$qualifierspace =0;}
    if (/\s/)
    {
      if ($qualifierspace) {$_ = '';}
      else {$_ = "\a";}
      $qualifierspace++;
    }
  }
  continue
  {
    $qualifiers .= $_;
    $_ = &getnext;
  }
  @qualifierarray = split(/\a/,$qualifiers);
  $quotecount = 0;
  undef %qualifiers;
  shift(@qualifierarray);  #the first thingy in the array is blank
  #Turn @qualifierarray into %qualifiers. If we have a qualifier w/o a value,
  #give it a value of 1.
  foreach $qual (@qualifierarray)
  {
    local ($left, $right) = split(/\cD/, $qual);
    $left =~ tr/A-Z/a-z/;
    $right =~ tr/A-Z/a-z/;
    if ($right)
    {
      $right =~ s/\"//g;  #remove quotes.
      $qualifiers{$left} = $right;
    }
    else {$qualifiers{$left} = 1;}
  }
  #Eat the rest of the tag
  while (/[^>]/) { $_ = &getnext; }

  $name =~ tr/A-Z/a-z/;  #convert the tag to lowercase
  $thistag = $name;
}

sub parse_html
{
    $name = $thistag;
  if ($latexequiv{$name})       #is there a direct equivalent to this tag?
  { print  $latexequiv{$name}; return 1;}
  #start of an anchor.
  if ($name =~ /^a$/i)
  {
    #only italicize with HREFs.
    if ($qualifiers{'href'})
    {
        print "{\\it ";
      $hrefina++;
    }
    else 
    {$hrefina = 0;}
    return 1;
  }
  #end of an anchor.
  if ($name =~ /^\/a$/i)
  {
    if ($hrefina)
    { print "}";}
    $hrefina = 0;               # 
    return 1;
  }  
  if ($name =~ /^p$/i)
  {
      if ($paralignopen{$qualifiers{'align'}})
      {
          print "$paralignopen{$qualifiers{'align'}} %\n";
          $thisparagraph = $qualifiers{'align'};
      }
      else {print "$paragraph "; $thisparagraph = "";}
  }
  if ($name =~ /^\/p$/i)
  {
      if ($thisparagraph)
      {
          print "$paralignend{$thisparagraph} %\n";
          $thisparagraph = "";
      }
      return 1;
  }     
  #Print out any ALT="" stuff in an <img src...>
  if ($name =~ /^img/i)
  {
      $buffer .= reverse $qualifiers{'alt'};
      return 1;
  }
  if ($spacers{$name})      #does this tag add whitespace?
  { $metspace++; }
  if ($ignore{$name})
  { $metspace++; return 1; }
  if ($obeylines{$name})    #are we opening a pre, xmp, or listing?
  {
    print  $obeylines{$name};
    $obeylines++;
    $preserve_whitespace++;
    return 1;
  }
  if ($closeobeylines{$name})      #are we closing one of the above?
  {
    print  $closeobeylines{$name};
    $obeylines--;
    $preserve_whitespace--;
    return 1;
  }
  if ($itemliststarter{$name})
  {
    if ($dllevel)
    {
      if ($dtlevel)
      {
        print "]";
        $dtlevel = 0;
      }
      print $latexlistequiv{'/dl'};
    }
    print $latexlistequiv{$name};
  }
  #Are we closing a list?  If so, do we then have to re-open a <dl>?
  if ($itemlistcloser{$name})
  {
    print $latexlistequiv{$name};
    if ($dllevel)
    {
      print $latexlistequiv{'dl'};
      print "\\item[] ";
      $dllevel--;
    }
  }
  #Are we opening a <dt>  If so, do we have to close one?
  if ($name =~ /^dt/i)
  {
    if ($dtlevel)
    { print  "]"; }
    print  "\\item[";
    $dtlevel++;
    return 1;
  }
  #Ah, now we're finally closing a <dt>.  But wait!  Have we already closed
  #one?
  if ($dtcloser{$name})
  {
    if ($dtlevel)
    { print  "]"; }
    $dtlevel = 0;
    return 1;
  }
  #Now we're closing a <dl>.  Do we have to close a <dt> first?
  if ($name =~ /\/dl/i)
  {
    if ($dtlevel)
    { print "]"; }
    $dtlevel = 0;
    $dllevel = 0;
    print $latexlistequiv{'/dl'};
    return 1;
  }
  #Now we're opening a dl.
  if ($name =~ /^dl/i)
  {
    $dllevel++;
    print $latexlistequiv{'dl'};
    return 1;
  }
  #print out the base href.
  if ($name =~ /^base$/i)
  {
    print "\\newline{\\tt $qualifiers{'href'}}";
    return 1;
  }
  if ($name =~ /^font$/i)
  {
      $qualifiers{'size'} =~ s/\"//g;
      if ($qualifiers{'size'} =~ /^\d$/)
       {
          push(@oldfontsizes,$fontsize); $fontsize = $qualifiers{'size'};
          print "$fontlist[$fontsize] ";
      } 
      else
      {
          push(@oldfontsizes,$fontsize);
          $fontsize += $qualifiers{'size'};
          print $fontopener, $fontlist[$fontsize+1];
      }
      return 1;
  }
  if ($name =~ /^\/font$/i)
  {
      print "$fontcloser";
      $fontsize = pop(@oldfontsizes);
      return 1;                 
  }                              
  if ($latexinmathopen{$name})  
  { 
      print "$latexinmathopen{$name} ";
      $inmath++;
  }
  if ($latexinmathclose{$name}) 
  { 
      print "$latexinmathclose{$name} ";
      $inmath--;
  }

    return 1;
}


__END__
